#include "fields.h"

void DistributeFields(const FieldDefinition field_def[], unsigned fields, int max_width, int width[])
{
	int total_min=0;
	int total_pref=0;
	int total_max=0;
	for(unsigned i=0; i<fields; i++) {
		total_min += field_def[i].min_width;
		total_pref += field_def[i].pref_width;
		total_max += field_def[i].max_width;
	}
	int current_width=fields-1;
	if(max_width<total_pref) {
		for(unsigned i=0; i<fields; i++) {
			width[i] = field_def[i].min_width;
			current_width += field_def[i].min_width;
		}
		bool progress=true;
		while(current_width<max_width && progress) {
			progress=false;
			for(unsigned i=0; i<fields; i++) {
				if(width[i]<field_def[i].pref_width) {
					width[i]++;
					current_width++;
					progress=true;
				}
			}
		}
	} else {
		for(unsigned i=0; i<fields; i++) {
			width[i] = field_def[i].pref_width;
			current_width += field_def[i].pref_width;
		}
		bool progress=true;
		while(current_width<max_width && progress) {
			progress=false;
			for(unsigned i=0; i<fields; i++) {
				if(width[i]<field_def[i].max_width) {
					width[i]++;
					current_width++;
					progress=true;
				}
			}
		}
	}
}

void PaintHeaderFields(WINDOW *w, const FieldDefinition field_def[], unsigned fields, const int width[])
{
	wclear(w);
	wattron(w,A_REVERSE);
	wmove(w,0,0);
	for(unsigned i=0; i<fields; i++) {
		wprintw(w,(char*)"%-*.*s",width[i],width[i],field_def[i].header_name);
		if(i+1<fields) waddch(w,' ');
	}
}
